package eu.jonahbauer.raytracing.render.image;

import eu.jonahbauer.raytracing.render.canvas.Canvas;
import org.jetbrains.annotations.NotNull;

import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Path;

public interface ImageWriter {
    default void write(@NotNull Canvas image, @NotNull Path path) throws IOException {
        try (var out = Files.newOutputStream(path)) {
            write(image, out);
        }
    }

    void write(@NotNull Canvas canvas, @NotNull OutputStream out) throws IOException;
}
