package eu.jonahbauer.raytracing.render.material;

import eu.jonahbauer.raytracing.render.color.ColorSpaces;
import eu.jonahbauer.raytracing.render.material.DielectricMaterial.SellmeierRefractiveIndex;
import eu.jonahbauer.raytracing.render.spectrum.Spectra;
import eu.jonahbauer.raytracing.render.texture.CheckerTexture;
import org.jetbrains.annotations.NotNull;

public final class Materials {
    public static final @NotNull Material GLASS = new DielectricMaterial(new SellmeierRefractiveIndex(
            1.0361212, 0.231792344, 1.01046945,
            6.00069867E-3, 2.00179144E-2, 1.03560653E2
    ));

    public static final @NotNull Material MIRROR = new MetallicMaterial(ColorSpaces.sRGB.albedo(0.7, 0.7, 0.7));

    public static final @NotNull Material DEBUG = new DirectionalMaterial(
            new LambertianMaterial(new CheckerTexture(50.0, ColorSpaces.sRGB.albedo(1.0, 0.0, 1.0), Spectra.BLACK)),
            new LambertianMaterial(new CheckerTexture(50.0, ColorSpaces.sRGB.albedo(1.0, 1.0, 1.0), Spectra.BLACK))
    );

    private Materials() {
        throw new UnsupportedOperationException();
    }
}
